Index: sasmodels/models/ellipsoid.py
===================================================================
--- sasmodels/models/ellipsoid.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/models/ellipsoid.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,170 @@
+# ellipsoid model
+# Note: model title and parameter table are inserted automatically
+r"""
+The form factor is normalized by the particle volume.
+
+Definition
+----------
+
+The output of the 2D scattering intensity function for oriented ellipsoids
+is given by (Feigin, 1987)
+
+.. math::
+
+    P(q,\alpha) = \frac{\text{scale}}{V} f^2(q) + \text{background}
+
+where
+
+.. math::
+
+    f(q) = \frac{3 (\Delta rho)) V (\sin[qr(R_p,R_e,\alpha)] \
+                 - \cos[qr(R_p,R_e,\alpha)])}{[qr(R_q,R_b,\alpha)]^3}
+
+and
+
+.. math::
+
+    r(R_p,R_e,\alpha) = \left[ R_e^2 \sin^2 \alpha + R_p^2 \cos^2 \alpha \right]^{1/2}
+
+
+$\alpha$ is the angle between the axis of the ellipsoid and $\vec q$,
+$V$ is the volume of the ellipsoid, $R_p$ is the polar radius along the
+rotational axis of the ellipsoid, $R_e$ is the equatorial radius perpendicular
+to the rotational axis of the ellipsoid and $\Delta \rho$ (contrast) is the
+scattering length density difference between the scatterer and the solvent.
+
+To provide easy access to the orientation of the ellipsoid, we define
+the rotation axis of the ellipsoid using two angles $\theta$ and $\phi$.
+These angles are defined in Figure :num:`figure #cylinder-orientation`.
+For the ellipsoid, $\theta$ is the angle between the rotational axis
+and the $z$-axis.
+
+NB: The 2nd virial coefficient of the solid ellipsoid is calculated based
+on the $R_p$ and $R_e$ values, and used as the effective radius for
+$S(Q)$ when $P(Q) \dot S(Q)$ is applied.
+
+.. figure:: img/image121.JPG
+
+    The output of the 1D scattering intensity function for randomly oriented
+    ellipsoids given by the equation above.
+
+
+The $\theta$ and $\phi$ parameters are not used for the 1D output. Our
+implementation of the scattering kernel and the 1D scattering intensity
+use the c-library from NIST.
+
+.. figure:: img/image122.JPG
+
+    The angles for oriented ellipsoid.
+
+Validation
+----------
+
+Validation of our code was done by comparing the output of the 1D model
+to the output of the software provided by the NIST (Kline, 2006).
+Figure :num:`figure ellipsoid-comparison-1d` below shows a comparison of
+the 1D output of our model and the output of the NIST software.
+
+.. _ellipsoid-comparison-1d:
+
+.. figure:: img/image123.JPG
+
+    Comparison of the SasView scattering intensity for an ellipsoid
+    with the output of the NIST SANS analysis software.  The parameters
+    were set to: *scale=1.0*, *a=20 |Ang|*, *b=400 |Ang|*,
+    *sld-solvent_sld=3e-6 |Ang^-2|*, and *background=0.01 |cm^-1|*.
+
+Averaging over a distribution of orientation is done by evaluating the
+equation above. Since we have no other software to compare the
+implementation of the intensity for fully oriented ellipsoids, we can
+compare the result of averaging our 2D output using a uniform distribution
+$p(\theta,\phi) = 1.0$.  Figure :num:`figure #ellipsoid-comparison-2d`
+shows the result of such a cross-check.
+
+.. _ellipsoid-comparison-2d:
+
+.. figure:: img/image124.jpg
+
+    Comparison of the intensity for uniformly distributed ellipsoids
+    calculated from our 2D model and the intensity from the NIST SANS
+    analysis software. The parameters used were: *scale=1.0*,
+    *a=20 |Ang|*, *b=400 |Ang|*, *sld-solvent_sld=3e-6 |Ang^-2|*,
+    and *background=0.0 |cm^-1|*.
+
+The discrepancy above *q=0.3 |cm^-1|* is due to the way the form factors
+are calculated in the c-library provided by NIST. A numerical integration
+has to be performed to obtain *P(q)* for randomly oriented particles.
+The NIST software performs that integration with a 76-point Gaussian
+quadrature rule, which will become imprecise at high q where the amplitude
+varies quickly as a function of $q$. The SasView result shown has been
+obtained by summing over 501 equidistant points. Our result was found
+to be stable over the range of *q* shown for a number of points higher
+than 500.
+
+REFERENCE
+
+L A Feigin and D I Svergun. *Structure Analysis by Small-Angle X-Ray and Neutron Scattering*, Plenum,
+New York, 1987.
+"""
+
+from numpy import pi, inf
+
+name = "ellipsoid"
+title = "Ellipsoid of revolution with uniform scattering length density."
+
+description = """\
+P(q.alpha)= scale*f(q)^2 + background, where f(q)= 3*(sld
+		- solvent_sld)*V*[sin(q*r(Rp,Re,alpha))
+		-q*r*cos(qr(Rp,Re,alpha))]
+		/[qr(Rp,Re,alpha)]^3"
+
+     r(Rp,Re,alpha)= [Re^(2)*(sin(alpha))^2
+		+ Rp^(2)*(cos(alpha))^2]^(1/2)
+
+		sld: SLD of the ellipsoid
+		solvent_sld: SLD of the solvent
+		V: volume of the ellipsoid
+		Rp: polar radius of the ellipsoid
+		Re: equatorial radius of the ellipsoid
+"""
+
+parameters = [
+#   [ "name", "units", default, [lower, upper], "type",
+#     "description" ],
+    [ "sld", "1e-6/Ang^2", 4, [-inf,inf], "",
+      "Ellipsoid scattering length density" ],
+    [ "solvent_sld", "1e-6/Ang^2", 1, [-inf,inf], "",
+      "Solvent scattering length density" ],
+    [ "rpolar", "Ang",  20, [0, inf], "volume",
+      "Polar radius" ],
+    [ "requatorial", "Ang",  400, [0, inf], "volume",
+      "Equatorial radius" ],
+    [ "theta", "degrees", 60, [-inf, inf], "orientation",
+      "In plane angle" ],
+    [ "phi", "degrees", 60, [-inf, inf], "orientation",
+      "Out of plane angle" ],
+    ]
+
+source = [ "lib/J1.c", "lib/gauss76.c", "ellipsoid.c"]
+
+def ER(rpolar, requatorial):
+    import numpy as np
+
+    ee = np.empty_like(rpolar)
+    idx = rpolar > requatorial
+    ee[idx] = (rpolar[idx]**2 - requatorial[idx]**2)/rpolar[idx]**2
+    idx = rpolar < requatorial
+    ee[idx] = (requatorial[idx]**2 - rpolar[idx]**2)/requatorial[idx]**2
+    idx = rpolar == requatorial
+    ee[idx] = 2*rpolar[idx]
+    valid = (rpolar*requatorial != 0)
+    bd = 1.0-ee[valid]
+    e1 = np.sqrt(ee[valid])
+    b1 = 1.0 + np.arcsin(e1)/(e1*np.sqrt(bd))
+    bL = (1.0+e1)/(1.0-e1)
+    b2 = 1.0 + bd/2/e1*np.log(bL)
+    delta = 0.75*b1*b2
+
+    ddd = np.zeros_like(rpolar)
+    ddd[valid] = 2.0*(delta+1.0)*rpolar*requatorial**2
+    return 0.5*ddd**(1.0/3.0)
Index: sasmodels/models/lamellar.py
===================================================================
--- sasmodels/models/lamellar.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/models/lamellar.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,95 @@
+r"""
+Polydispersity in the bilayer thickness can be applied from the GUI.
+
+Definition
+----------
+
+The scattering intensity *I(q)* is
+
+.. math::
+
+    I(q) = 2\pi\frac{P(q){\delta q^2}
+
+
+The form factor is
+
+.. math::
+
+    P(q) = \frac{2\Delta\rho^2}{q^2}(1-cos(q\delta)
+
+
+where |delta| = bilayer thickness.
+
+The 2D scattering intensity is calculated in the same way as 1D, where the *q* vector is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 q_y^2}
+
+
+
+Our model uses the form factor calculations implemented in a c-library provided by the NIST Center for Neutron Research
+(Kline, 2006).
+
+.. figure:: img/image135.jpg
+
+    1D plot using the default values (w/1000 data point).
+
+
+Reference
+---------
+
+F Nallet, R Laversanne, and D Roux, J. Phys. II France, 3, (1993) 487-502
+
+also in J. Phys. Chem. B, 105, (2001) 11081-11088
+
+
+"""
+
+from numpy import pi, inf
+
+name = "lamellar"
+title = "Lyotropic lamellar phase with uniform SLD and random distribution"
+description = """\
+	[Dilute Lamellar Form Factor](from a lyotropic lamellar phase)
+		I(q)= 2*pi*P(q)/(delta *q^(2)), where
+		P(q)=2*(contrast/q)^(2)*(1-cos(q*delta))^(2))
+		thickness = layer thickness
+		sld = layer scattering length density
+		sld_solvent = solvent scattering length density
+		background = incoherent background
+		scale = scale factor
+"""
+
+parameters = [
+#   [ "name", "units", default, [lower, upper], "type",
+#     "description" ],
+    [ "sld", "1e-6/Ang^2", 1, [-inf,inf], "",
+      "Layer scattering length density" ],
+    [ "solvent_sld", "1e-6/Ang^2", 6, [-inf,inf], "",
+      "Solvent scattering length density" ],
+    [ "thickness", "Ang",  50, [0, inf], "volume",
+      "Bilayer thickness" ],
+    ]
+
+
+# No volume normalization despite having a volume parameter
+# This should perhaps be volume normalized?
+form_volume = """
+    return REAL(1.0);
+    """
+
+Iq = """
+    const real sub = sld - solvent_sld;
+    const real qsq = q*q;
+    return REAL(4.0e-4)*M_PI*sub*sub/qsq * (REAL(1.0)-cos(q*thickness))
+        / (thickness*qsq);
+    """
+
+Iqxy = """
+    // never called since no orientation or magnetic parameters.
+    return REAL(-1.0);
+    """
+
+# ER defaults to 0.0
+# VR defaults to 1.0
Index: sasmodels/models/sphere.py
===================================================================
--- sasmodels/models/sphere.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/models/sphere.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,49 @@
+r"""
+
+"""
+
+from numpy import pi, inf
+
+name = "sphere"
+title = "Spheres with uniform SLD"
+description = """\
+	[Sphere Form Factor]
+"""
+
+parameters = [
+#   [ "name", "units", default, [lower, upper], "type",
+#     "description" ],
+    [ "sld", "1e-6/Ang^2", 1, [-inf,inf], "",
+      "Layer scattering length density" ],
+    [ "solvent_sld", "1e-6/Ang^2", 6, [-inf,inf], "",
+      "Solvent scattering length density" ],
+    [ "radius", "Ang",  50, [0, inf], "volume",
+      "Sphere radius" ],
+    ]
+
+
+# No volume normalization despite having a volume parameter
+# This should perhaps be volume normalized?
+form_volume = """
+    return REAL(1.333333333333333)*M_PI*radius*radius*radius;
+    """
+
+Iq = """
+    real sn, cn;
+    const real qr = q*radius;
+    SINCOS(qr, sn, cn);
+    const real bes = (qr==REAL(0.0) ? REAL(1.0) : (REAL(3.0)*(sn-qr*cn))/(qr*qr*qr));
+    const real f = bes * (sld - solvent_sld) * form_volume(radius);
+    return REAL(1.0e-4)*f*f;
+    """
+
+
+Iqxy = """
+    // never called since no orientation or magnetic parameters.
+    return REAL(-1.0);
+    """
+
+def ER(radius):
+    return radius
+
+# VR defaults to 1.0
Index: sasmodels/models/triaxial_ellipsoid.c
===================================================================
--- sasmodels/models/triaxial_ellipsoid.c	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/models/triaxial_ellipsoid.c	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,85 @@
+real form_volume(real req_minor, real req_major, real rpolar);
+real Iq(real q, real sld, real solvent_sld,
+    real req_minor, real req_major, real rpolar);
+real Iqxy(real qx, real qy, real sld, real solvent_sld,
+    real req_minor, real req_major, real rpolar, real theta, real phi, real psi);
+
+real form_volume(real req_minor, real req_major, real rpolar)
+{
+    return REAL(1.333333333333333)*M_PI*req_minor*req_major*rpolar;
+}
+
+real Iq(real q,
+    real sld,
+    real solvent_sld,
+    real req_minor,
+    real req_major,
+    real rpolar)
+{
+    // if (req_minor > req_major || req_major > rpolar) return REAL(-1.0);  // Exclude invalid region
+
+    real sn, cn;
+    real st, ct;
+    //const real lower = REAL(0.0);
+    //const real upper = REAL(1.0);
+    real outer = REAL(0.0);
+    for (int i=0;i<76;i++) {
+        //const real cos_alpha = (Gauss76Z[i]*(upper-lower) + upper + lower)/2;
+        const real x = REAL(0.5)*(Gauss76Z[i] + REAL(1.0));
+        SINCOS(M_PI_2*x, sn, cn);
+        const real acosx2 = req_minor*req_minor*cn*cn;
+        const real bsinx2 = req_major*req_major*sn*sn;
+        const real c2 = rpolar*rpolar;
+
+        real inner = REAL(0.0);
+        for (int j=0;j<76;j++) {
+            const real y = REAL(0.5)*(Gauss76Z[j] + REAL(1.0));
+            const real t = q*sqrt(acosx2 + bsinx2*(REAL(1.0)-y*y) + c2*y*y);
+            SINCOS(t, st, ct);
+            const real fq = ( t==REAL(0.0) ? REAL(1.0) : REAL(3.0)*(st-t*ct)/(t*t*t) );
+            inner += Gauss76Wt[j] * fq * fq ;
+        }
+        outer += Gauss76Wt[i] * REAL(0.5) * inner;
+    }
+    //const real fq2 = (upper-lower)/2*outer;
+    const real fq2 = REAL(0.5)*outer;
+    const real s = (sld - solvent_sld) * form_volume(req_minor, req_major, rpolar);
+    return REAL(1.0e-4) * fq2 * s * s;
+}
+
+real Iqxy(real qx, real qy,
+    real sld,
+    real solvent_sld,
+    real req_minor,
+    real req_major,
+    real rpolar,
+    real theta,
+    real phi,
+    real psi)
+{
+    // if (req_minor > req_major || req_major > rpolar) return REAL(-1.0);  // Exclude invalid region
+
+    real stheta, ctheta;
+    real sphi, cphi;
+    real spsi, cpsi;
+    real st, ct;
+
+    const real q = sqrt(qx*qx + qy*qy);
+    const real qxhat = qx/q;
+    const real qyhat = qy/q;
+    SINCOS(theta*M_PI_180, stheta, ctheta);
+    SINCOS(phi*M_PI_180, sphi, cphi);
+    SINCOS(psi*M_PI_180, spsi, cpsi);
+    const real calpha = ctheta*cphi*qxhat + stheta*qyhat;
+    const real cnu = (-cphi*spsi*stheta + sphi*cpsi)*qxhat + spsi*ctheta*qyhat;
+    const real cmu = (-stheta*cpsi*cphi - spsi*sphi)*qxhat + ctheta*cpsi*qyhat;
+    const real t = q*sqrt(req_minor*req_minor*cnu*cnu
+                          + req_major*req_major*cmu*cmu
+                          + rpolar*rpolar*calpha*calpha);
+    SINCOS(t, st, ct);
+    const real fq = ( t==REAL(0.0) ? REAL(1.0) : REAL(3.0)*(st-t*ct)/(t*t*t) );
+    const real s = (sld - solvent_sld) * form_volume(req_minor, req_major, rpolar);
+
+    return REAL(1.0e-4) * fq * fq * s * s;
+}
+
Index: sasmodels/models/triaxial_ellipsoid.py
===================================================================
--- sasmodels/models/triaxial_ellipsoid.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/models/triaxial_ellipsoid.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,130 @@
+# triaxial ellipsoid model
+# Note: model title and parameter table are inserted automatically
+r"""
+All three axes are of different lengths with $R_a \le R_b <= R_c$
+**Users should maintain this inequality for all calculations**.
+
+.. math::
+
+    P(q) = \text{scale} V \left< f^2(q) \right> + \text{background}
+
+where the volume $V = 4/3 \pi R_a R_b R_c$, and the averaging
+$\left< \cdots \right>$ is applied over all orientations for 1D.
+
+.. figure:: img/image128.JPG
+
+    Ellipsoid schematic.
+
+The returned value is in units of |cm^-1|, on absolute scale.
+
+Definition
+----------
+
+The form factor calculated is
+
+.. math::
+
+    P(q) = \frac{\text{scale}}{V}\int_0^1\int_0^1 \
+        \Phi^2(qR_a^2\cos^2( \pi x/2) + qR_b^2\sin^2(\pi y/2)(1-y^2) + c^2y^2) \
+        dx dy
+
+where
+
+.. math::
+
+    \Phi(u) = 3 u^{-3} (\sin u - u \cos u)
+
+To provide easy access to the orientation of the triaxial ellipsoid,
+we define the axis of the cylinder using the angles $\theta$, $\phi$
+and $\psi$. These angles are defined on
+Figure :num:`figure #triaxial-ellipsoid-angles`.
+The angle $\psi$ is the rotational angle around its own $c$ axis
+against the $q$ plane. For example, $\psi = 0$ when the
+$a$ axis is parallel to the $x$ axis of the detector.
+
+.. _triaxial-ellipsoid-angles:
+
+.. figure:: img/image132.JPG
+
+    The angles for oriented ellipsoid.
+
+The radius-of-gyration for this system is  $Rg^2 = (R_a R_b R_c)^2/5$.
+
+The contrast is defined as SLD(ellipsoid) - SLD(solvent).  In the
+parameters, *a* is the minor equatorial radius, *b* is the major
+equatorial radius, and c is the polar radius of the ellipsoid.
+
+NB: The 2nd virial coefficient of the triaxial solid ellipsoid is
+calculated based on the polar radius $R_p = R_c$ and equatorial
+radius $R_e = \sqrt{R_a R_b}$, and used as the effective radius for
+$S(Q)$ when $P(Q) \dot S(Q)$ is applied.
+
+.. figure:: img/image130.JPG
+
+    1D plot using the default values (w/1000 data point).
+
+Validation
+----------
+
+Validation of our code was done by comparing the output of the
+1D calculation to the angular average of the output of 2D calculation
+over all possible angles.
+Figure :num:`figure #triaxial-ellipsoid-compare` shows the comparison where
+the solid dot refers to averaged 2D while the line represents the
+result of 1D calculation (for 2D averaging, 76, 180, and 76 points
+are taken for the angles of $\theta$, $\phi$, and $\psi$ respectively).
+
+.. _triaxial-ellipsoid-compare:
+
+.. figure:: img/image131.GIF
+
+    Comparison between 1D and averaged 2D.
+
+Our model uses the form factor calculations implemented in a c-library provided by the NIST Center for Neutron Research
+(Kline, 2006)
+
+REFERENCE
+
+L A Feigin and D I Svergun, *Structure Analysis by Small-Angle X-Ray and Neutron Scattering*, Plenum,
+New York, 1987.
+"""
+
+from numpy import pi, inf
+
+name = "triaxial_ellipsoid"
+title = "Ellipsoid of uniform scattering length density with three independent axes."
+
+description = """\
+Note: During fitting ensure that the inequality ra<rb<rc is not
+	violated. Otherwise the calculation will
+	not be correct.
+"""
+
+parameters = [
+#   [ "name", "units", default, [lower, upper], "type",
+#     "description" ],
+    [ "sld", "1e-6/Ang^2", 4, [-inf,inf], "",
+      "Ellipsoid scattering length density" ],
+    [ "solvent_sld", "1e-6/Ang^2", 1, [-inf,inf], "",
+      "Solvent scattering length density" ],
+    [ "req_minor", "Ang",  20, [0, inf], "volume",
+      "Minor equitorial radius" ],
+    [ "req_major", "Ang",  400, [0, inf], "volume",
+      "Major equatorial radius" ],
+    [ "rpolar", "Ang",  10, [0, inf], "volume",
+      "Polar radius" ],
+    [ "theta", "degrees", 60, [-inf, inf], "orientation",
+      "In plane angle" ],
+    [ "phi", "degrees", 60, [-inf, inf], "orientation",
+      "Out of plane angle" ],
+    [ "psi", "degrees", 60, [-inf, inf], "orientation",
+      "Out of plane angle" ],
+    ]
+
+source = [ "lib/J1.c", "lib/gauss76.c", "triaxial_ellipsoid.c"]
+
+def ER(req_minor, req_major, rpolar):
+    import numpy as np
+    from .ellipsoid import ER as ellipsoid_ER
+    return ellipsoid_ER(rpolar, np.sqrt(req_minor*req_major))
+
Index: sasmodels/sasview_model.py
===================================================================
--- sasmodels/sasview_model.py	(revision ff7119b4ad066090cdffae80706883cef3d80399)
+++ sasmodels/sasview_model.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -6,9 +6,9 @@
 
 try:
-    import pyopencl
-    from .gen import opencl_model as load_model
-except ImportError:
+    from .gpu import load_model
+except ImportError,exc:
+    warnings.warn(str(exc))
     warnings.warn("OpenCL not available --- using ctypes instead")
-    from .gen import dll_model as load_model
+    from .dll import load_model
 
 
@@ -246,5 +246,9 @@
             # Check whether we have a list of ndarrays [qx,qy]
             qx, qy = qdist
-            return self.calculate_Iq(qx, qy)
+            partype = self._model.info['partype']
+            if not partype['orientation'] and not partype['magnetic']:
+                return self.calculate_Iq(np.sqrt(qx**2+qy**2))
+            else:
+                return self.calculate_Iq(qx, qy)
 
         elif isinstance(qdist, np.ndarray):
Index: sasmodels/weights.py
===================================================================
--- sasmodels/weights.py	(revision ff7119b4ad066090cdffae80706883cef3d80399)
+++ sasmodels/weights.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -42,6 +42,9 @@
         """
         sigma = self.width * center if relative else self.width
-        if sigma == 0:
-            return np.array([center], 'd'), np.array([1.], 'd')
+        if sigma == 0 or self.npts < 2:
+            if lb <= center <= ub:
+                return np.array([center], 'd'), np.array([1.], 'd')
+            else:
+                return np.array([], 'd'), np.array([], 'd')
         return self._weights(center, sigma, lb, ub)
 
